// Potrosac.java - Klasa potrosaca.

package skladiste;
import  usluge.Polje;

public class Potrosac extends Thread {
  
  private static int ukId = 0;    // Poslednje korisceni identifikator.
  private int id = ++ukId;        // Identifikator potrosaca.
  private Skladiste skladiste;    // Pridruzeno skladiste.
  private int minVreme, maxVreme; // Najkrace i najduze vreme potorsnje.
  private Polje polje;            // Polje za prikaz stanja potrosaca.

  public Potrosac                               // Inicijalizacija.
    (Skladiste sklad, int minVr, int maxVr, Polje p) { 
    minVreme = minVr; maxVreme = maxVr; 
    skladiste = sklad; polje = p;
  }
  
  public Potrosac (Skladiste sklad, int minVr, int maxVr) 
    { this (sklad, minVr, maxVr, null); }
  
  public Potrosac (Skladiste sklad) 
    { this (sklad, 1000, 2000); }
  
  public void run () {                          // Telo niti.
    while (true) {
      int vredn = skladiste.uzmi ();
      if (polje != null) polje.pisi (id*100000 + vredn);
      long vreme = (long)(minVreme + Math.random() * (maxVreme-minVreme));
      try { Thread.sleep (vreme); } catch (InterruptedException e) {}
    }
  }
}
