// BrzaMetoda.java - Klasa za uredjivanje brzom metodom
//                   (Quick Sort).

package uredjeni;
import  usluge.Uporedljiv;

public class BrzaMetoda implements Uredjivac {
  
  public void uredi (Uporedljiv[] niz)   // Uredjivanje niza.
    { uredi (niz, 0, niz.length-1); }
    
  private void uredi (Uporedljiv[] a, int p, int q) {
    if (q > p+1) {
      int i = p-1, j = q;
      while (true) {
        do i++; while (a[i].ispred (a[q]));
        do j--; while (j>=0 && a[q].ispred (a[j]));
      if (i >= j) break;
        Uporedljiv b = a[i]; a[i] = a[j]; a[j] = b;
      }
      Uporedljiv b = a[i]; a[i] = a[q]; a[q] = b;
      uredi (a, p, i-1); uredi (a, i+1, q);
    }
  }
  
  public String toString ()              // Naziv algoritma.
    { return "Brza metoda"; }
}