// SkladisteT.java - Ispitivanje sistema proizvodjac/potrosac.

import java.awt.*;
import java.awt.event.*;
import usluge.*;
import skladiste.*;

class SkladisteT extends Frame {
  
  public SkladisteT (String[] vpar) {        // SASTAVLJANJE PROZORA I
    super ("Proizvodjaci/potrosaci");        //   INICIJALIZACIJA SISTEMA:
    setBounds (100, 100, 300, 200);
    addWindowListener (new WindowAdapter () {
      public void windowClosing (WindowEvent d) { System.exit (0); }
    });
    
    Panel ploca = new Panel (); add (ploca, "North"); // Ploca za natpise.
    ploca.setLayout (new GridLayout (1, 3));
    ploca.add (new Label ("Proizvodjaci:"));
    ploca.add (new Label ("Skladiste:"));
    ploca.add (new Label ("Potrosaci:"));
    
    add (ploca = new Panel ());                       // Ploca za podatke.
    ploca.setLayout (new GridLayout (1, 3));
    List lstProizvodjaci = new List ();
    TextArea tksSkladiste = new TextArea ();
    List lstPotrosaci = new List ();
    ploca.add (lstProizvodjaci);
    ploca.add (tksSkladiste);
    ploca.add (lstPotrosaci);
                                             // Pametri rada:
    int kap    = Integer.parseInt (vpar[0]), // - kapacitet skladista,
        brPro  = Integer.parseInt (vpar[1]), // - broj proizvodjaca,
        minPro = Integer.parseInt (vpar[2]), // - najkrace i najduze vreme
        maxPro = Integer.parseInt (vpar[3]), //   proizvodnje,
        brPot  = Integer.parseInt (vpar[4]), // - broj potrosaca,
        minPot = Integer.parseInt (vpar[5]), // - najkrace i najduze vreme
        maxPot = Integer.parseInt (vpar[6]); //   potrosnje.
    try {
      Skladiste skladiste = new Skladiste (kap, new Polje (tksSkladiste));
      for (int i=0; i<brPro; i++) {
        lstProizvodjaci.add ("***");
        (new Proizvodjac (skladiste, minPro, maxPro,
                          new Polje (lstProizvodjaci,i))).start ();
      }
      for (int i=0; i<brPot; i++) {
        lstPotrosaci.add ("***");
        (new Potrosac (skladiste, minPot, maxPot,
                       new Polje (lstPotrosaci, i))).start ();
      }
    } catch (GPoljeNeOdgovara g) {}
  }
  
  public static void main (String[] vpar) {  // GLAVNI PROGRAM.
    new SkladisteT (vpar).setVisible (true);
  }
}